routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'SiteController@index')->name('home');

// Helper Routes
Route::post('/project/media', 'SiteController@get_project_media');

// Auth Routes
Route::group(['middleware' => 'guest', 'prefix' => 'admin'], function() {
    Route::get('/login', 'Backend\LoginController@index')->name('login');
    Route::post('/login', 'Auth\LoginController@login');
    Route::post('/password/email', 'Auth\ForgotPasswordController@sendResetLinkEmail')->name('password.email');
    Route::get('/password/reset', 'Auth\ForgotPasswordController@showLinkRequestForm')->name('password.request');
    Route::post('/password/reset', 'Auth\ResetPasswordController@reset');
    Route::get('/password/reset/{token}', 'Auth\ResetPasswordController@showResetForm')->name('password.reset');
    //Route::get('/admin/register', 'Auth\RegisterController@showRegistrationForm')->name('register');
    //Route::post('/admin/register', 'Auth\RegisterController@register');
});
Route::get('/admin/logout', 'Auth\LoginController@logout')->name('logout');

// Backend Routes
Route::group(['middleware' => 'backend', 'prefix' => 'admin'], function() {

    // Pasword Change
    Route::get('/password', 'Backend\ChangePasswordController@index')->name('password.change');
    Route::post('/password/update', 'Backend\ChangePasswordController@update')->name('password.update');

    // Dashboard Home
    Route::get('/', 'Backend\BackendController@index')->name('admin');

    // Resource Projects
    Route::resource('project', 'Backend\ProjectController');
    Route::get('project/{project}/ask', 'Backend\ProjectController@ask_delete')->name('project.ask_delete');
    Route::post('project/update_order', 'Backend\ProjectController@update_order')->name('project.update_order');

    // Resource Media
    Route::get('project/{project}/media', 'Backend\MediaController@index')->name('project.media.index');
    Route::get('project/{project}/media/create', 'Backend\MediaController@create')->name('project.media.create');
    Route::post('project/{project}/media', 'Backend\MediaController@store')->name('project.media.store');
    Route::get('project/{project}/media/{media}/edit', 'Backend\MediaController@edit')->name('project.media.edit');
    Route::match(['put', 'patch'], 'project/{project}/media/{media}', 'Backend\MediaController@update')->name('project.media.update');
    Route::get('project/{project}/media/{media}/ask', 'Backend\MediaController@ask_delete')->name('project.media.ask_delete');
    Route::delete('project/{project}/media/{media}', 'Backend\MediaController@destroy')->name('project.media.destroy');
    Route::post('project/{project}/media/update_order', 'Backend\MediaController@update_order')->name('project.media.update_order');

    // Resource Sections
    Route::resource('section', 'Backend\SectionController', ['except' => [
        'create', 'store', 'destroy'
    ]]);

});

app/Project.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Project extends Model
{
    protected $fillable = [
        'name',
        'description',
        'cover',
        'published',
        'order'
    ];

    public function media() {
        return $this->hasMany('App\Media')->orderBy('order');;
    }
}

app/Http/Controllers/Backend/BackendController.php
<?php

namespace App\Http\Controllers\Backend;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Section;
use App\Project;
use App\Media;

class BackendController extends Controller
{
    public function index() {
        $sections = count(Section::get());
        $projects = count(Project::get());
        $media    = count(Media::get());

        return view('backend.dashboard')->with(compact('sections', 'projects', 'media'));
    }
}

app/Http/Controllers/Backend/ChangePasswordController.php
<?php

namespace App\Http\Controllers\Backend;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Auth;
use Hash;

class ChangePasswordController extends Controller
{
    /*
    |--------------------------------------------------------------------------
    | Change Password Controller
    |--------------------------------------------------------------------------
    |
    | This controller is responsible for handling password change requests.
    |
    */

    public function index() {

        return view('backend.user.password.change');
    }

    public function update(Request $request) {

        if ($request->password == $request->password_repeat) {

            $user = Auth::user();

            $user->password = Hash::make($request->password);
            $user->save();

            $response = [
                'title'    => 'Password Updated',
                'action'   => 'update',
                'type'     => 'success',
                'response' => 'Your password was updated successfully.'
            ];

        } else {

            $response = [
                'title'    => 'Passwords Didn\'t match',
                'action'   => 'update',
                'type'     => 'failure',
                'response' => 'Your password wasn\'t updated. Both password fields have to be the same.'
            ];

        }

        return view('backend.user.password.response')->with(compact('response'));
    }
}

app/Http/Controllers/Backend/LoginController.php
<?php

namespace App\Http\Controllers\Backend;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class LoginController extends Controller
{
    public function index() {
        return view('backend.auth.login');
    }
}

app/Http/Controllers/Backend/MediaController.php
<?php

namespace App\Http\Controllers\Backend;

use Illuminate\Http\Request;
use Illuminate\Http\Response;
use App\Http\Controllers\Controller;
use App\MediaType;
use App\Media;
use App\Project;
use App\Traits\ImageTrait;
use Storage;
use File;

class MediaController extends Controller
{
    use ImageTrait;

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index($project_id)
    {
        $project = Project::find($project_id);
        return view('backend.media.list')->with(compact('project'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create($project_id)
    {
        $project = Project::find($project_id);
        $media_types = MediaType::get();
        $media   = $project->media;

        $media_groups = [];
        foreach ($media as $item) {
            if ($item->type->is_group) {
                $media_groups[$item->id] = $item;
            }
        }

        return view('backend.media.create')->with(compact('project','media_types', 'media_groups'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request, $project_id)
    {

        $media = new Media;
        $media->project_id = $project_id;

        // Set type
        $media->media_type_id = $request->type;

        switch ($media->type->code) {
            case 'image':

                $extension = $this->get_mime_extension(File::mimeType($request->file('media_file')));

                if ($extension == 'error') {
                    return back()->with(['error' => 'img']);
                }

                $media->save();

                // Store image file
                $file = Storage::putFileAs(
                    'public/media/'.$project_id, $request->file('media_file'), $media->id.$extension
                );
                $media->media_url = 'storage/media/'.$project_id.'/'.$media->id.$extension;

                break;

            case 'youtube':
            case 'vimeo':
                $slug = str_replace($media->type->external_url, '', $request->url);
                $media->external_slug = $slug;
                break;

            case 'image_slide':
                $media->name = $request->name;
                break;

            case 'link':
                $media->media_url = $request->url;
                break;
        }

        //Ordering
        if($request->group && $request->group != 0) {
            $media->group = $request->group;
            $last_media = Media::where('group', $request->group)->orderByDesc('order')->first();
            if ($last_media != null) {
                $media->order = $last_media->order + 1;
            } else {
                $media->order = 1;
            }
        } else {
            $last_media = Media::where('project_id', $project_id)->orderByDesc('order')->first();
            if ($last_media != null) {
                $media->order = $last_media->order + 1;
            } else {
                $media->order = 1;
            }
        }

        $media->save();

        $response = [
            'title'    => 'Media Item Created',
            'action'   => 'create',
            'type'     => 'success',
            'response' => 'Item was created successfully.'
        ];

        return view('backend.media.response')->with(compact('media', 'response'));
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($project_id, $media_id)
    {
        return redirect()->route('project.media.edit', ['project' => $project_id, 'media' => $media_id]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($project_id, $media_id)
    {
        $project = Project::find($project_id);
        $media = Media::find($media_id);
        $media_groups = [];
        foreach ($project->media as $item) {
            if ($item->type->is_group) {
                $media_groups[$item->id] = $item;
            }
        }

        return view('backend.media.edit')->with(compact('media', 'media_groups'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $project_id, $media_id)
    {

        $media = Media::find($media_id);

        if($request->group) {
            $media->group = $request->group;
        }

        // Check type
        if($media->type->is_external == 0 && $media->type->is_group == 0) {

            // Type is file
            if ($request->hasFile('media_file')) {
                $extension = $this->get_mime_extension(File::mimeType($request->file('media_file')));

                if ($extension == 'error') {
                    return back()->with(['error' => 'img']);
                }

                // Store image file
                $file = Storage::putFileAs(
                    'public/media/'.$project_id, $request->file('media_file'), $media->id.$extension
                );
                $media->media_url = 'storage/media/'.$project_id.'/'.$media->id.$extension;
            }

        } elseif($media->type->is_external == 1 && $media->type->is_group == 0) {

            // Type is link
            $slug = str_replace($media->type->external_url, '', $request->url);
            $media->external_slug = $slug;

        } elseif($media->type->is_external == 0 && $media->type->is_group == 1) {

            // Type is group
            $media->name = $request->name;

        }

        $media->save();

        $response = [
            'title'    => 'Media Item Updated',
            'action'   => 'create',
            'type'     => 'success',
            'response' => 'Item was updated successfully.'
        ];

        return view('backend.media.response')->with(compact('media', 'response'));
    }

    /**
     * Update media display order
     * @param  |Request $request
     * @return \Response
     */
    public function update_order(Request $request)
    {

        foreach ($request->order as $id => $order) {
            $media = Media::findOrFail($id);
            $media->order = $order;
            $media->save();
        }

        return redirect()->route('project.media.index', $request->project_id);
    }

    /**
     * Ask for deleting resource confirmation
     * @param  \Request $request
     * @return \Response
     */
    public function ask_delete($project_id, $media_id)
    {
        $media = Media::find($media_id);
        $response = [
            'title'    => 'Delete Media',
            'action'   => 'ask',
            'type'     => 'success',
            'response' => 'Are you sure you want to delete this media item?'
        ];

        return view('backend.media.response')->with(compact('media', 'response'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($project_id, $media_id)
    {
        $media = Media::findOrFail($media_id);

        $response = [
            'title'    => 'Media Item Deleted',
            'action'   => 'delete',
            'type'     => 'success',
            'response' => 'Item was deleted successfully.'
        ];

        $media->delete();

        return view('backend.media.response')->with(compact('media', 'response'));
    }

}

app/Http/Controllers/Backend/SectionController.php
<?php

namespace App\Http\Controllers\Backend;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Section;

class SectionController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $sections = Section::get();
        return view('backend.section.list')->with(compact('sections'));
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        return redirect()->route('section.edit', $id);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $section = Section::find($id)->toArray();

        return view('backend.section.edit')->with('section', $section);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {

        $section = Section::findOrFail($id);

        $section->title   = $request->title;
        $section->content = $request->content;

        $section->save();

        $response = [
            'title'    => 'Section Updated',
            'action'   => 'update',
            'type'     => 'success',
            'response' => 'Section \''.$section->name.'\' was updated successfully.'
        ];

        return view('backend.section.response')->with(compact('section', 'response'));
    }
}

resources/views/backend/project/create.blade.php
@extends('backend.layouts.dashboard')
@section('title', 'New Project')

@section('content')
    <h1>New Project</h1>
    <hr>

    <form action="{{route('project.store')}}" method="post" enctype="multipart/form-data">
        {{csrf_field()}}
        <label>Name</label>
        <input type="text" name="name" value="{{old('name')}}" required>
        <label>Description</label>
        <textarea name="description" required>{{old('description')}}</textarea>
        <label>Cover</label>
        <input type="file" name="cover" value="{{old('cover')}}" required>
        <label>Published Status</label>
        <fieldset>
            <input type="checkbox" name="published" id="published" checked> Published
        </fieldset>

        <input type="submit" class="button button-default" name="submit" value="Create">
    </form>
@endsection

@section('javascript')
    <script src="{{asset('/assets/js/vendor/trumbowyg/trumbowyg.js')}}"></script>
    <script src="{{asset('/assets/js/rich-text.js')}}"></script>
@endsection

resources/views/backend/project/edit.blade.php
@extends('backend.layouts.dashboard')
@section('title', 'Edit Project')

@section('content')
    <h1>Edit Project</h1>
    <hr>

    <form action="{{route('project.update', $project->id)}}" method="post" enctype="multipart/form-data">

        {{csrf_field()}}
        {{method_field('patch')}}

        <label>Name</label>
        <input type="text" name="name" value="{{$project->name}}" required>
        <label>Description</label>
        <textarea name="description" required>{{$project->description}}</textarea>

        <label class="margin-top">Published Status</label>
        <fieldset>
            <input type="checkbox" name="published" id="published" @if ($project->published) checked @endif> Published
        </fieldset>

        <label class="margin-top">Cover</label>
        <hr>
        <div class="grid-x grid-margin-x">
            <div class="cell medium-5 large-3">
                Current Cover
                <img src="{{asset($project->cover)}}" alt="">
            </div>
            <div class="cell medium-7 large-9 flex-container align-middle">
                <div class="grid-y">
                    <div class="cell">
                        <label>Change Cover</label>
                    </div>
                    <div class="cell">
                        <input type="file" name="cover">
                    </div>
                </div>
            </div>
        </div>
        <hr>

        <button type="submit" class="button button-default" name="submit"><i class='fa fa-floppy-o'></i> Save</button>
        <a class="button" href="{{route('project.media.index', $project->id)}}"><i class='fa fa-image'></i> Manage project media</a>

    </form>

@endsection

@section('javascript')
    <script src="{{asset('/assets/js/vendor/trumbowyg/trumbowyg.js')}}"></script>
    <script src="{{asset('/assets/js/rich-text.js')}}"></script>
@endsection

resources/views/backend/project/list.blade.php
@extends('backend.layouts.dashboard')
@section('title', 'Projects')

@section('content')

    <h1>Projects</h1>
    <hr>

    @if (count($projects) !== 0)

        <div class="grid-x">
            <div class="cell auto text-right">
                <a href="{{route('project.create')}}" class="button clear primary"><i class='fa fa-plus'></i> Add Project</a>
            </div>
        </div>

        <form action="{{route('project.update_order')}}" method="post">

            {{csrf_field()}}

            <table class="table-hover">
                <tr>
                    <th>id</th>
                    <th>Name</th>
                    <th>Published</th>
                    <th>Order</th>
                    <th>Edit</th>
                    <th>Media</th>
                    <th>Delete</th>
                </tr>

                @foreach ($projects as $project)
                    <tr class="text-center">
                        <td>{{$project['id']}}</td>
                        <td>{{$project['name']}}</td>
                        <td>
                            @if ($project['published'])
                                Yes
                            @else
                                No
                            @endif
                        </td>
                        <td>
                            <input type="number" name="order[{{$project->id}}]" value="{{$project->order}}" class="order-input">
                        </td>
                        <td><a href="{{route('project.edit', $project->id)}}"><i class="fa fa-pencil"></i></a></td>
                        <td><a href="{{route('project.media.index', $project->id)}}"><i class='fa fa-image'></i></a></td>
                        <td><a href="{{route('project.ask_delete', $project->id)}}"><i class='fa fa-trash'></i></a></td>
                    </tr>
                @endforeach
                @if (count($projects) > 1)
                    <tr>
                        <td colspan="3">Remember that project ordering is descendent. (Higher number is first).</td>
                        <td class="text-center"><button type="submit" class="button"><i class='fa fa-floppy-o'></i> Save projects order</button></td>
                        <td colspan="3"></td>
                    </tr>
                @endif
            </table>

        </form>

    @else

        <p>You haven publish any project yet. <a href="{{route('project.create')}}">Add one</a></p>

    @endif

@endsection

resources/views/backend/project/response.blade.php
@extends('backend.layouts.response')


@section('response')

    <p>{{$response['response']}}</p>

    @if ($response['action'] == 'ask')

        <form action="{{route('project.destroy', $project->id)}}" method="post">

            {{csrf_field()}}
            {{method_field('delete')}}

            <a class="button alert" href="{{route('project.index')}}">No</a>

            <button class="button success" type="submit">Yes</button>
            <a class="button" href="{{route('project.index')}}"><i class='fa fa-list'></i> Go to projects list</a>

        </form>

    @elseif ($response['action'] == 'delete')

        <a class="button" href="{{route('project.index')}}"><i class='fa fa-list'></i> Go to projects list</a>

    @else

        <a class="button" href="{{route('project.edit', $project->id)}}"><i class='fa fa-pencil'></i> Edit project</a>
        <a class="button" href="{{route('project.media.index', $project->id)}}"><i class='fa fa-image'></i> Manage project media</a>
        <a class="button" href="{{route('project.index')}}"><i class='fa fa-list'></i> Go to projects list</a>

    @endif

@endsection